



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【转载】Java是传值还是传引用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【转载】Java是传值还是传引用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 16:56:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1. 简单类型是按值传递的</strong></p>
<p>　　Java 方法的参数是简单类型的时候，是按值传递的 (pass by value)。这一点我们可以通过一个简单的例子来说明：</p>
<blockquote><pre class="prettyprint linenums"><tt>/* 例 1 */<br />
/**<br />
 * @(#) Test.java<br />
 * @author fancy<br />
 */<br />
public class Test {<br />
    public static void test(boolean test) {<br />
        test = ! test;<br />
        System.out.println("In test(boolean) : test = " + test);<br />
    }<br />
    public static void main(String[] args) {<br />
        boolean test = true;<br />
        System.out.println("Before test(boolean) : test = " + test);<br />
        test(test);<br />
        System.out.println("After test(boolean) : test = " + test);<br />
    }<br />
}</tt></pre></blockquote>
<p>　　运行结果：</p>
<blockquote><p>Before test(boolean) : test = true<br />In test(boolean) : test = false<br />After test(boolean) : test = true</p></blockquote>
<p>　　不难看出，虽然在 test(boolean) 方法中改变了传进来的参数的值，但对这个参数源变量本身并没有影响，即对 main(String[]) 方法里的 test 变量没有影响。那说明，参数类型是简单类型的时候，是按值传递的。以参数形式传递简单类型的变量时，实际上是将参数的值作了一个拷贝传进方法函数的，那么在方法函数里再怎么改变其值，其结果都是只改变了拷贝的值，而不是源值。</p>
<p>　　<strong>2. 什么是引用</strong></p>
<p>　　Java 是传值还是传引用，问题主要出在对象的传递上，因为 Java 中简单类型没有引用。既然争论中提到了引用这个东西，为了搞清楚这个问题，我们必须要知道引用是什么。</p>
<p>　　简单的说，引用其实就像是一个对象的名字或者别名 (alias)，一个对象在内存中会请求一块空间来保存数据，根据对象的大小，它可能需要占用的空间大小也不等。访问对象的时候，我们不会直接是访问对象在内存中的数据，而是通过引用去访问。引用也是一种数据类型，我们可以把它想象为类似 C 语言中指针的东西，它指示了对象在内存中的地址&mdash;&mdash;只不过我们不能够观察到这个地址究竟是什么。</p>
<p>　　如果我们定义了不止一个引用指向同一个对象，那么这些引用是不相同的，因为引用也是一种数据类型，需要一定的内存空间来保存。但是它们的值是相同的，都指示同一个对象在内存的中位置。比如</p>
<blockquote><p>String a = "Hello";<br />String b = a;</p></blockquote>
<p>　　这里，a 和 b 是不同的两个引用，我们使用了两个定义语句来定义它们。但它们的值是一样的，都指向同一个对象 "Hello"。也许你还觉得不够直观，因为 String 对象的值本身是不可更改的 (像 b = "World"; b = a; 这种情况不是改变了 "World" 这一对象的值，而是改变了它的引用 b 的值使之指向了另一个 String 对象 a)。那么我们用 StringBuffer 来举一个例子：</p>
<blockquote><pre class="prettyprint linenums"><tt>/* 例 2 */<br />
/**<br />
 * @(#) Test.java<br />
 * @author fancy<br />
 */<br />
public class Test {<br />
    public static void main(String[] args) {<br />
        StringBuffer a = new StringBuffer("Hello");<br />
        StringBuffer b = a;<br />
        b.append(", World");<br />
        System.out.println("a is " + a);<br />
    }<br />
}</tt></pre></blockquote>
<p>　　运行结果：</p>
<blockquote><p>a is Hello, World</p></blockquote>
<p>　　这个例子中 a 和 b 都是引用，当改变了 b 指示的对象的值的时候，从输出结果来看，a 所指示的对象的值也改变了。所以，a 和 b 都指向同一个对象即包含 "Hello" 的一个 StringBuffer 对象。</p>
<p>　　这里我描述了两个要点：</p>
<ol><li>引用是一种数据类型，保存了对象在内存中的地址，这种类型即不是我们平时所说的简单数据类型也不是类实例(对象)；</li>
<li>不同的引用可能指向同一个对象，换句话说，一个对象可以有多个引用，即该类类型的变量。</li></ol>
<p>　　<strong>3. 对象是如何传递的呢</strong></p>
<p>　　关于对象的传递，有两种说法，即&ldquo;它是按值传递的&rdquo;和&ldquo;它是按引用传递的&rdquo;。这两种说法各有各的道理，但是它们都没有从本质上去分析，即致于产生了争论。</p>
<p>　　既然现在我们已经知道了引用是什么东西，那么现在不妨来分析一下对象作是参数是如何传递的。还是先以一个程序为例：</p>
<blockquote><pre class="prettyprint linenums"><tt>/* 例 3 */<br />
/**<br />
 * @(#) Test.java<br />
 * @author fancy<br />
 */<br />
public class Test {<br />
    public static void test(StringBuffer str) {<br />
        str.append(", World!");<br />
    }<br />
    public static void main(String[] args) {<br />
        StringBuffer string = new StringBuffer("Hello");<br />
        test(string);<br />
        System.out.println(string);<br />
    }<br />
}</tt></pre></blockquote>
<p>　　运行结果：</p>
<p>　　Hello, World!</p>
<p>　　test(string) 调用了 test(StringBuffer) 方法，并将 string 作为参数传递了进去。这里 string 是一个引用，这一点是勿庸置疑的。前面提到，引用是一种数据类型，而且不是对象，所以它不可能按引用传递，所以它是按值传递的，它么它的值究竟是什么呢？是对象的地址。</p>
<p>　　由此可见，对象作为参数的时候是按值传递的，对吗？错！为什么错，让我们看另一个例子：</p>
<blockquote><pre class="prettyprint linenums"><tt>/* 例 4 */<br />
/**<br />
 * @(#) Test.java<br />
 * @author fancy<br />
 */<br />
public class Test {<br />
    public static void test(String str) {<br />
        str = "World";<br />
    }<br />
    public static void main(String[] args) {<br />
        String string = "Hello";<br />
        test(string);<br />
        System.out.println(string);<br />
    }<br />
}</tt></pre></blockquote>
<p>　　运行结果：</p>
<blockquote><p>Hello</p></blockquote>
<p>　　为什么会这样呢？因为参数 str 是一个引用，而且它与 string 是不同的引用，虽然它们都是同一个对象的引用。str = "World" 则改变了 str 的值，使之指向了另一个对象，然而 str 指向的对象改变了，但它并没有对 "Hello" 造成任何影响，而且由于 string 和 str 是不同的引用，str 的改变也没有对 string 造成任何影响，结果就如例中所示。</p>
<p>　　其结果是推翻了参数按值传递的说法。那么，对象作为参数的时候是按引用传递的了？也错！因为上一个例子的确能够说明它是按值传递的。</p>
<p>　　结果，就像光到底是波还是粒子的问题一样，Java 方法的参数是按什么传递的问题，其答案就只能是：即是按值传递也是按引用传递，只是参照物不同，结果也就不同。</p>
<p>　　<strong>4. 正确看待传值还是传引用的问题</strong></p>
<p>　　要正确的看待这个问题必须要搞清楚为什么会有这样一个问题。</p>
<p>　　实际上，问题来源于 C，而不是 Java。</p>
<p>　　C 语言中有一种数据类型叫做指针，于是将一个数据作为参数传递给某个函数的时候，就有两种方式：传值，或是传指针，它们的区别，可以用一个简单的例子说明：</p>
<blockquote><pre class="prettyprint linenums"><tt>/* 例 5 */<br />
/**<br />
 * @(#) test.c<br />
 * @author fancy<br />
 */<br />
void SwapValue(int a, int b) {<br />
    int t = a;<br />
    a = b;<br />
    b = t;<br />
}<br />
void SwapPointer(int * a, int * b) {<br />
    int t = * a;<br />
    * a = * b;<br />
    * b = t;<br />
}<br />
void main() {<br />
    int a = , b = ;<br />
    printf("1 : a = %d, b = %d\n", a, b);<br />
    SwapValue(a, b);<br />
    printf("2 : a = %d, b = %d\n", a, b);<br />
    SwapPointer(&amp;a, &amp;b);<br />
    printf("3 : a = %d, b = %d\n", a, b);<br />
}</tt></pre></blockquote>
<p>　　运行结果：</p>
<blockquote><p>1 : a = 0, b = 1<br />2 : a = 0, b = 1<br />3 : a = 1, b = 0</p></blockquote>
<p>　　大家可以明显的看到，按指针传递参数可以方便的修改通过参数传递进来的值，而按值传递就不行。</p>
<p>　　当 Java 成长起来的时候，许多的 C 程序员开始转向学习 Java，他们发现，使用类似 SwapValue 的方法仍然不能改变通过参数传递进来的简单数据类型的值，但是如果是一个对象，则可能将其成员随意更改。于是他们觉得这很像是 C 语言中传值/传指针的问题。但是 Java 中没有指针，那么这个问题就演变成了传值/传引用的问题。可惜将这个问题放在 Java 中进行讨论并不恰当。</p>
<p>　　讨论这样一个问题的最终目的只是为了搞清楚何种情况才能在方法函数中方便的更改参数的值并使之长期有效。</p>
<p>　　Java 中，改变参数的值有两种情况，第一种，使用赋值号&ldquo;=&rdquo;直接进行赋值使其改变，如例 1 和例 4；第二种，对于某些对象的引用，通过一定途径对其成员数据进行改变，如例 3。对于第一种情况，其改变不会影响到方法该方法以外的数据，或者直接说源数据。而第二种方法，则相反，会影响到源数据&mdash;&mdash;因为引用指示的对象没有变，对其成员数据进行改变则实质上是改变的该对象。</p>
<p><strong>　　5. 如何实现类似 swap 的方法</strong></p>
<p>　　传值还是传引用的问题，到此已经算是解决了，但是我们仍然不能解决这样一个问题：如果我有两个 int 型的变量 a 和 b，我想写一个方法来交换它们的值，应该怎么办？</p>
<p>　　结论很让人失望&mdash;&mdash;没有办法！因此，我们只能具体情况具体讨论，以经常使用交换方法的排序为例：</p>
<blockquote><pre class="prettyprint linenums"><tt>/** 例 6 */<br />
/**<br />
 * @(#) Test.java<br />
 * @author fancy<br />
 */<br />
public class Test {<br />
    public static void swap(int[] data, int a, int b) {<br />
        int t = data[a];<br />
        data[a] = data[b];<br />
        data[b] = t;<br />
    }<br />
    public static void main(String[] args) {<br />
        int[] data = new int[];<br />
        for (int i = ; i &lt; ; i++) {<br />
            data[i] = (int) (Math.random() * );<br />
            System.out.print(" " + data[i]);<br />
        }<br />
        System.out.println();<br />
        for (int i = ; i &lt; ; i++) {<br />
            for (int j = i; j &lt; ; j++) {<br />
                if (data[i] &gt; data[j]) {<br />
                    swap(data, i, j);<br />
                }<br />
            }<br />
        }<br />
        for (int i = ; i &lt; ; i++) {<br />
            System.out.print(" " + data[i]);<br />
        }<br />
        System.out.println();<br />
    }<br />
}</tt></pre></blockquote>
<p>　　运行结果(情况之一)：</p>
<blockquote><p>78 69 94 38 95 31 50 97 84 1<br />1 31 38 50 69 78 84 94 95 97</p></blockquote>
<p>　　swap(int[] data, int a, int b) 方法在内部实际上是改变了 data 所指示的对象的成员数据，即上述讨论的第二种改变参数值的方法。希望大家能够举一反三，使用类似的方法来解决相关问题。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnvr228.html">关于前期在云服务器上部署TOMCAT服务器的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/m962onvq.html">安装CocoaPods报错 - &lbrack;&excl;&rsqb; The dependency &grave;AFNetworking &lpar;~&amp;gt&semi; 3&period;1&period;0&rpar;&grave; is not used in any concrete target&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8op65pq.html">BZOJ4644 &colon; 经典傻逼题</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxmr4d9.html">UITabBarController常见代理方法的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q76g618.html">在View页面，使用&commat;if&lpar;&rpar;&lbrace; &rcub;输出判断正确的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0z0zwq.html">戴文的Linux内核专题：01介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd6zjr8.html">Balanced Lineup&lpar;最简单的线段树题目&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnz6z08.html">oracle必须启动的服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdejr38.html">Android画廊控件之Gallery</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xl3308.html">mybatis update语句参数正常， 数据没有更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn15y2q.html">JSP通过SmartUpload上传文件实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv4lnoq.html">python之路-模块 WebDriver API</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wownxq.html">Python学习笔记3（数据结构）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jo3mv8.html">痞子衡嵌入式：飞思卡尔i&period;MX RT系列MCU启动那些事（6）- Bootable image格式与加载&lpar;elftosb&sol;&period;bd&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvje2r8.html">LAB6 SOAP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwoyox9.html">【译】理解JavaScript闭包&mdash;&mdash;新手指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5mknmq.html">《Linux内核分析》第八周学习小结 进程的切换和系统的一般执行过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rl51n9.html">hive数据查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r74m08.html">sql server 学习笔记 &lpar; backup 备份方案 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2l0nx9.html">Ubantu-Nginx部署</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/ql1mez69.html">git查看各个branch之间的关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/902vv4nq.html">Django&lowbar;博客项目 引入外部js文件内含模板语法无法正确获取值得说明和处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/953xx6m8.html">noip2017颓废记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk1ko18.html">IIS并发连接数及性能优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/902v2y4q.html">Easyui的DateBox日期格式化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko1mm3q.html">k8s如何管理Pod&lpar;rc、rs、deployment&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjedexq.html">Java基础-SSM之Spring快速入门篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpm4ml9.html">Java基础-Java中的内存分配与回收机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppjxe49.html">bzoj千题计划246：bzoj2242&colon; &lbrack;SDOI2011&rsqb;计算器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvevr2y9.html">scala 基础知识总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
